﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using System.Collections;
using System.Xml;
using System.Xml.Linq;
using Telerik.Windows.Controls;

namespace TreeView_XMLDataBinding
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            //treeView1
            XElement rootElement = XElement.Load("../../RadTreeViewBindingToXml.xml");
            GenericNode rootNode = new GenericNode(rootElement);
            radTreeView1.ItemsSource = rootNode.Nodes;
            //treeView2
            XElement rootElement2 = XElement.Load("../../AnotherStructure.xml");
            GenericNode rootNode2 = new GenericNode(rootElement2);
            radTreeView2.ItemsSource = rootNode2.Nodes;
        }
    }

    class GenericNode
    {
        private ObservableCollection<GenericNode> _Nodes = new ObservableCollection<GenericNode>();
        private ObservableCollection<GenericKeyValue> _Attributes = new ObservableCollection<GenericKeyValue>();
        public GenericNode(XElement Element)
        {
            this.Name = Element.Name.LocalName;
            this._Nodes.AddRange(Element.Elements().Select(e => new GenericNode(e)));
            this._Attributes.AddRange(
                Element.Attributes().Select(a => new GenericKeyValue(a.Name.LocalName, a.Value)));
        }

        public string Name { get; private set; }
        public ObservableCollection<GenericNode> Nodes
        {
            get
            {
                return this._Nodes;
            }
        }
        public ObservableCollection<GenericKeyValue> Attributes
        {
            get
            {
                return this._Attributes;
            }
        }
    }

    class GenericKeyValue
    {
        public GenericKeyValue(string Key, string Value)
        {
            this.Key = Key;
            this.Value = Value;
        }
        public string Key { get; set; }
        public string Value { get; set; }
    }
}
